global  mua siga

var         Lambda, C, s, atilde, M, U, V, N, Rho, W, MC, Y, Ha, Fa,R, Pstar, Q1, Q2, Dist, Pip, Yw, Tau;


parameters  betaa, epsilon_p, alphap, gammap, bc, sigmac, mup, eps_taxbar, sx, nuf, nub, mua, siga, vv, rhoi, rhopip, rhoy, rhoA, atildebar, 
            mtilde, Hauc, xsoui, eta0, Wbar0, bu0, fi0,eta, fi, bu, devss, 
            Lambdabar, Cbar, sbar, Mbar, Ubar, Vbar, Nbar, Rhobar, Wbar, MCbar, Ybar, 
            Abar, Habar, Fabar, Rbar, Pstarbar, Q1bar, Q2bar, Distbar, Pipbar, Ywbar, Taubar;




betaa      = 0.99;
epsilon_p  = 11;
alphap     = 0.75;
gammap     = 0.5;
bc         = 0.75;
sigmac     = 0.729;
mup        = epsilon_p/(epsilon_p-1);
eps_taxbar = 1/(epsilon_p-1);
sbar       = 0.1;
sx         = 0.068;
nuf        = 0;
nub        = 0.74;
mua        = 0;
siga       = 0.12;
vv         = 0.6;

rhoi       = 0.8; 
rhopip     = 1.5;
rhoy       = 0.25;
rhoA       = 0.9; 

Ybar    = 1;
Pibar   = 1;
Nbar    = 0.88;
Taubar  = 0.95;

Fabar     = (sbar-sx)/(1-sx);
atildebar = logninv(Fabar,mua,siga);
Mbar      = Nbar*(sbar/(1-sbar));
Ubar      = 1 - Nbar;
Vbar      = Mbar/Taubar;
//eta       = 0.025/Vbar;
mtilde    = Mbar/((Ubar^vv)*(Vbar^(1-vv)));
Rhobar    = Mbar/Ubar;

Hauc      = quad(afaa,atildebar,8);
Habar     = Hauc/(1-logncdf(atildebar,mua,siga));

Pipbar    = 1;
Pstarbar  = 1;
MCbar     = (1+eps_taxbar)*Pstarbar/mup;
Distbar   = Pstarbar^(-epsilon_p);
Ywbar     = Distbar*Ybar;
Abar      = Ywbar/(Nbar*Habar);

xsoui   = 0.5;

eta0    = 0.1/Vbar;
Wbar0   = (1/(1+((Fabar)/(1-Fabar))*nuf))*(Abar*MCbar*Habar + eta0/Taubar  - (1/(betaa*(1-sbar)))*eta0/Taubar);
bu0     = nub*Wbar0;
fi0     = nuf*Wbar0;
 
paramm0  = [eta0 ; fi0 ; bu0 ; Wbar0 ];
parammc  = [nuf ; nub ; Taubar ; betaa ; sbar ; MCbar ; Habar ; Fabar ; Rhobar; sx ; atildebar ; Abar ; xsoui];
paramm   = [paramm0 ; parammc];

options  = optimset('Display','iter');
[xx,Fval,exitflag] = fsolve('funx2',paramm,options,parammc);     

eta  = xx(1);
fi     = xx(2);
bu     = xx(3);
Wbar   = xx(4);


//Wbar      = Abar*MCbar*Habar + eta/Taubar - ((Fabar)/(1-Fabar))*fi - (1/(betaa*(1-sbar)))*eta/Taubar;
//xsoui     = (Wbar-bu)/(MCbar*Habar + eta*Rhobar/Taubar + (1-(1-Rhobar)*(1-sx)*betaa*(Lambdabar)/(Lambdabar))*fi - bu);

Cbar      = Ybar - eta*Vbar;
Lambdabar = (Cbar - Cbar*bc)^(-1/sigmac);
Rbar      = 1/betaa - 1;
Q1bar     = Ybar*MCbar/(1-alphap*betaa);
Q2bar     = (1+eps_taxbar)*Ybar/(1-alphap*betaa) ;

devss  =  0.2;


// ----- Check model's steady state ----


    a1 = Lambdabar     - (Cbar-bc*Cbar)^(-1/sigmac);
    a1 = (1/(1+Rbar))  - betaa*(Lambdabar/Lambdabar)*(1/(Pipbar));
    a1 = Ywbar         - Abar*Nbar*Habar;
    a1 = Ubar          - 1 + Nbar;
    a1 = Mbar          - mtilde*(Ubar^vv)*(Vbar^(1-vv));
    a1 = sbar          - sx - (1-sx)*Fabar;
    a1 = Nbar          - (1-sbar)*(Nbar + Mbar);
    a1 = Rhobar        - Mbar/Ubar;
    a1 = Taubar        - Mbar/Vbar;

    disp('--------------------------------')
    a1 = eta/Taubar    - betaa*(Lambdabar/Lambdabar)*(1-sbar)*(Abar*MCbar*Habar - Wbar + eta/Taubar - ((Fabar)/(1-Fabar))*fi);
    a1 = Wbar          - xsoui*(MCbar*Habar + eta*Rhobar/Taubar + (1-(1-Rhobar)*(1-sx)*betaa*(Lambdabar)/(Lambdabar))*fi) - (1-xsoui)*bu;
    a1 = atildebar     - (1/(MCbar*(1-xsoui)))*(xsoui*(eta*Rhobar/Taubar + (1-(1-Rhobar)*(1-sx)*betaa*(Lambdabar)/(Lambdabar))*fi) + (1-xsoui)*bu - eta/Taubar - fi);
    disp('--------------------------------')

    a1 = Pstarbar      - mup*Q1bar/Q2bar;
    a1 = Q1bar         - Ybar*MCbar - alphap*betaa*Q1bar;
    a1 = Q2bar         - (1+eps_taxbar)*Ybar - alphap*betaa*Q2bar;
    a1 = 1             - (1-alphap)*Pstarbar^(1-epsilon_p) - alphap*Pipbar^(gammap*(1-epsilon_p))*Pipbar^(epsilon_p-1) ;
    a1 = Distbar       - (1-alphap)*Pstarbar^(-epsilon_p)  - alphap*Pipbar^(epsilon_p)*Pipbar^(-epsilon_p*gammap)*Distbar;
    a1 = Ywbar         - Distbar*Ybar;

    a1 = Ybar          - Cbar - eta*Vbar;

    a1 = (1+Rbar)/(1+Rbar) - (((1+Rbar)/(1+Rbar))^(rhoi))*((Pipbar/Pipbar)^((1-rhoi)*rhopip))*((Ybar/Ybar)^((1-rhoi)*rhoy));

// ----------------------------------------



model;
    Lambda     = (C-bc*C(-1))^(-1/sigmac);
    (1/(1+R))  = betaa*(Lambda(+1)/Lambda)*(1/(Pip(+1)));
    Ha         = quad(afaa,atilde,8);
    Yw         = Abar*N(-1)*Ha;
    Tau        = M/V; 
    Rho        = M/U; 
    U          = 1-N(-1);
    M          = (mtilde+devss)*(U^vv)*(V^(1-vv));
    s          = sx + (1-sx)*Fa; 
    Fa         = logncdf(atilde,mua,siga);
    N          = (1-s(+1))*(N(-1) + M);
    eta/Tau    = betaa*(Lambda(+1)/Lambda)*(1-s(+1))*(Abar*MC(+1)*Ha(+1) - W(+1) + eta/Tau(+1) - ((Fa(+1))/(1-Fa(+1)))*fi);
    W          = xsoui*(MC*Ha + eta*Rho/Tau + (1-(1-Rho)*(1-sx)*betaa*(Lambda(+1))/(Lambda))*fi) + (1-xsoui)*bu;
    atilde     = (1/(MC*(1-xsoui)))*(xsoui*(eta*Rho/Tau + (1-(1-Rho)*(1-sx)*betaa*(Lambda(+1))/(Lambda))*fi) + (1-xsoui)*bu - eta/Tau - fi);


    Pstar      = mup*Q1/Q2; 
    Q1         = Y*MC + alphap*betaa*Q1(+1);
    Q2         = (1+eps_taxbar)*Y + alphap*betaa*Q2(+1);
    1          = (1-alphap)*Pstar^(1-epsilon_p) + alphap*Pip(-1)^(gammap*(1-epsilon_p))*Pip^(epsilon_p-1) ;
    Dist       = (1-alphap)*Pstar^(-epsilon_p)  + alphap*Pip^(epsilon_p)*Pip(-1)^(-epsilon_p*gammap)*Dist(-1);
    Yw         = Dist*Y;

    Y          = C + eta*V;

    (1+R)/(1+Rbar) = (((1+R(-1))/(1+Rbar))^(rhoi))*((Pip/Pipbar)^((1-rhoi)*rhopip))*((Y/Ybar)^((1-rhoi)*rhoy));


end;

initval;
Lambda = Lambdabar; 
C      = Cbar;
s      = sbar; 
atilde = atildebar; 
M      = Mbar;
U      = Ubar; 
V      = Vbar; 
N      = Nbar; 
Rho    = Rhobar; 
W      = Wbar; 
MC     = MCbar; 
Y      = Ybar; 
//A      = Abar; 
Ha     = Habar; 
Fa     = Fabar;
R      =  Rbar; 
Pstar  = Pstarbar; 
Q1     = Q1bar; 
Q2     = Q2bar;
Dist   = Distbar; 
Pip    = Pipbar; 
Yw     = Ywbar; 
Tau    = Taubar; 
end;



steady(solve_algo=0);
//check ;
